package de.wenzlaff.twbibel;

/**
 * Alle 66 Bibelbücher.
 * 
 * In der richtigen Reihenfolge.
 * 
 * Ohne Umlaute.
 * 
 * 1.,2. und 3. durch ERSTER_, ZWEITER_ und DRITER_ ersetzt.
 * 
 * Blanks zusammengezogen.
 * 
 * @author Thomas Wenzlaff
 *
 */
public enum Bibelbuecher {

	// AT
	/** 1. Mose (Genesis). */
	ERSTER_Mose,
	/** 2. Mose. */
	ZWEITER_Mose, DRITTER_MOSE, VIERTER_MOSE, FUENFTER_MOSE, Josua, Richter, Ruth, ERSTER_Samuel, ZWEITER_Samuel, ERSTER_Könige, ZWEITER_Könige,
	ERSTER_Chronika, ZWEITER_Chronika, Esra, Nehemia, Esther, Hiob, Psalmen, Sprueche, Prediger, HohesLied, Jesaja, Jeremia, Klagelieder, Hesekiel, Daniel,
	Hosea, Joel, Amos, Obadja, Jona, Micha, Nahum, Habakuk, Zephanja, Haggai, Sacharja, Maleachi,
	// NT
	Matthauus, Markus, Lukas, Johannes, Apostelgeschichte, Roemer, ERSTER_Korinther, ZWEITER_Korinther, Galater, Epheser, Philipper, Kolosser,
	ERSTER_Thessalonicher, ZWEITER_Thessalonicher, ERSTER_Timotheus, ZWEITER_Timotheus, Titus, Philemon, Hebraeer, Jakobus, ERSTER_Petrus, ZWEITER_Petrus,
	ERSTER_Johannes, ZWEITER_Johannes, DRITTER_Johannes, Judas, Offenbarung;

	/**
	 * Liefert alle Bibelbücher Namen als Enum mit Komma getrent.
	 * 
	 * @return String mit allen Kommaseparierten Bibelbüchern.
	 */
	public static String getAlleBibelbuecher() {
		StringBuffer b = new StringBuffer();
		for (Bibelbuecher buch : Bibelbuecher.values()) {
			b.append(buch);
			b.append(", ");
		}

		return b.toString();
	}

	public String getBibelschreiber() {
		return Bibel.getBibel().get(this.ordinal()).getSchreiber();
	}

	public Integer getMaxKapitel() {
		return Bibel.getBibel().get(this.ordinal()).getMaxKapitel();
	}

	public Integer getNrInBibel() {
		return Bibel.getBibel().get(this.ordinal()).getNrInBibel();
	}

	public String getNamel() {
		return Bibel.getBibel().get(this.ordinal()).getName();
	}

}
